// BorrowerAdministrationGUI.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.3. 2007.05.27
 * Copyright 2003 by Michael Claudius
 * All rights reserved ?
 */

package library2007;

import javax.swing.*;

public class BorrowerAdministrationGUI extends javax.swing.JFrame {
    
    /** Creates new form BorrowerAdministrationGUI */
    public BorrowerAdministrationGUI() {
        initComponents();
        borrowerCol = new BorrowerCollection();
        borrowerHandler = new BorrowerAdministrationHandler();
    }
    
    Borrower b;
    BorrowerCollection borrowerCol;
    BorrowerAdministrationHandler borrowerHandler;
    
    private void showNumbers1() {
        //int num = borrowerCol.numberOfBorrowers();
        int num = borrowerHandler.getNumbers();
        String numStr = new Integer(num).toString();
        numberTextField.setText(numStr);
    }
    private void showNumbers() {
        //int num = borrowerCol.numberOfBorrowers();
        int num = borrowerCol.numberOfBorrowers();
        String numStr = new Integer(num).toString();
        numberTextField.setText(numStr);
    }   
    
    private void fileHandling() {
        new BorrowerFileHandlingGUI(borrowerCol).setVisible(true);
        this.setFocusable(true);
        showNumbers();
    }
    
    /** Ass. Create a borrower and add to collection */
    private void createBorrower() {
        
        dataArea.setText("");
        
        String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");
        String name = JOptionPane.showInputDialog("State name of borrower: ");
        
        String yearStr = JOptionPane.showInputDialog("State year of registration: ");
        int year = Integer.parseInt(yearStr);
        
        //String bType = JOptionPane.showInputDialog("Type of borrower:\n"+"Adult", "Child");
        Object[] possibleValues = { "Adult", "Child"};
        String  bType = (String) JOptionPane.showInputDialog(null, "Choose Borrower Type", "Input",
                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);
        
        b = new Borrower(cprNo, name, bType, year);
        borrowerCol.addBorrower(b);
        showNumbers();
    }
    
    private void registerBorrower() {
        
        dataArea.setText("");
        
        String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");
        String name = JOptionPane.showInputDialog("State name of borrower: ");
        
        String yearStr = JOptionPane.showInputDialog("State year of registration: ");
        int year = Integer.parseInt(yearStr);
        
        //String bType = JOptionPane.showInputDialog("Type of borrower:\n"+"Adult", "Child");
        Object[] possibleValues = { "Adult", "Child"};
        String  bType = (String) JOptionPane.showInputDialog(null, "Choose Borrower Type", "Input",
                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);
        
        borrowerHandler.enterBorrowerInfo(cprNo, name, bType, year);
        showNumbers();
    }
    
    
    /**Ass. 6 Show last handled borrower */
    private void showBorrower() {
        dataArea.append(b.borrowerData());
        dataArea.append(printEmptyLines(2));
    }
    
    /**Ass. 6 Show all borrowers */
    private void showAllBorrowers1() {
        allDataArea.setText(borrowerHandler.allBorrowersData());
    }
    
    private void showAllBorrowers() {
        allDataArea.setText(borrowerCol.allBorrowersData());
        showNumbers();
    }
    /**Ass. 7 & 8 Search for a borrower and present search result */
    private void findBorrower() {
        
        dataArea.setText("");
        
        Object[] possibleValues = { "Index", "CprNo"};
        String  searchStr = (String) JOptionPane.showInputDialog(null, "Choose Search Type", "Input",
                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);
        b = null;
        if (searchStr.equals("CprNo") ){
            String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");
            b = borrowerCol.getBorrower(cprNo);
        } else
            if ( searchStr.equals("Index") ){
            String indexStr = JOptionPane.showInputDialog("State index of borrower: ");
            int index = Integer.parseInt(indexStr);
            b = borrowerCol.getBorrower(index);
            }
        if ( b != null )
            showBorrower();
        else
            dataArea.setText("No borrower found");
    }
    
    /**Ass. 9 & 10 Remove for a borrower and present the removed borrower */
    private void removeBorrower() {
        
        dataArea.setText("");
        
        Object[] possibleValues = { "Index", "CprNo"};
        String  searchStr = (String) JOptionPane.showInputDialog(null, "Choose Search Type", "Input",
                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);
        b = null;
        if (searchStr.equals("CprNo") ){
            String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");
            b = borrowerCol.removeBorrower(cprNo);
        } else
            if ( searchStr.equals("Index") ){
            String indexStr = JOptionPane.showInputDialog("State index of borrower: ");
            int index = Integer.parseInt(indexStr);
            b = borrowerCol.removeBorrower(index);
            }
        
        if ( b != null )
            showBorrower();
        else
            dataArea.setText("No borrower found");
        
        showNumbers();
    }
    
    /**Ass. Read in name, find and show all borrowers by this name */
    /*public void findBorrowersByName()  {
     
        dataArea.setText("");
        String name = JOptionPane.showInputDialog("State the name to be searched for: ");
        BorrowerCollection foundBorrowers = borrowerCol.getBorrowersByName(name);
        allDataArea.setText(foundBorrowers.allBorrowersData());
     
    }*/
    private String printEmptyLines(int noLines) {
        String s = "";
        for (int i = 0; i < noLines; i++)
            s = s +  "\n";
        return s;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        allDataArea = new javax.swing.JTextArea();
        dataLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        dataArea = new javax.swing.JTextArea();
        showButton = new javax.swing.JButton();
        searchButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        showlButton3 = new javax.swing.JButton();
        showAllButton = new javax.swing.JButton();
        dataLabel = new javax.swing.JLabel();
        numberTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        startButton = new javax.swing.JButton();
        fileButton = new javax.swing.JButton();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        allDataArea.setColumns(20);
        allDataArea.setRows(5);
        jScrollPane2.setViewportView(allDataArea);

        jPanel1.add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 280, -1, 170));

        dataLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 14));
        dataLabel1.setText("Borrower Data");
        jPanel1.add(dataLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(340, 20, -1, -1));

        dataArea.setColumns(20);
        dataArea.setRows(5);
        jScrollPane1.setViewportView(dataArea);

        jPanel1.add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 70, -1, 110));

        showButton.setText("Show Borrower");
        showButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showButtonActionPerformed(evt);
            }
        });

        jPanel1.add(showButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 90, 130, -1));

        searchButton.setText("Search Borrower");
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        jPanel1.add(searchButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 130, 130, -1));

        deleteButton.setText("Delete Borrower");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        jPanel1.add(deleteButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 170, 130, -1));

        showlButton3.setText("Edit Borrower");
        jPanel1.add(showlButton3, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 230, 130, -1));

        showAllButton.setText("Show All Borrowers");
        showAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showAllButtonActionPerformed(evt);
            }
        });

        jPanel1.add(showAllButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 310, -1, -1));

        dataLabel.setFont(new java.awt.Font("MS Sans Serif", 1, 14));
        dataLabel.setText("All Borrowers Data");
        jPanel1.add(dataLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 220, 130, -1));

        jPanel1.add(numberTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 280, 40, -1));

        jLabel1.setText("Total number");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 260, -1, -1));

        startButton.setText("Create Borrower");
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        jPanel1.add(startButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 50, 130, -1));

        fileButton.setText("File Handling");
        fileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileButtonActionPerformed(evt);
            }
        });

        jPanel1.add(fileButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 390, 130, -1));

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 0, 550, 460));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void fileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileButtonActionPerformed
// TODO add your handling code here:
        fileHandling();
    }//GEN-LAST:event_fileButtonActionPerformed
    
    private void showAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showAllButtonActionPerformed
// TODO add your handling code here:
        showAllBorrowers();
    }//GEN-LAST:event_showAllButtonActionPerformed
    
    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
// TODO add your handling code here:
        removeBorrower();
    }//GEN-LAST:event_deleteButtonActionPerformed
    
    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
// TODO add your handling code here:
        findBorrower();
    }//GEN-LAST:event_searchButtonActionPerformed
    
    private void showButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showButtonActionPerformed
// TODO add your handling code here:
        showBorrower();
    }//GEN-LAST:event_showButtonActionPerformed
    
    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
// TODO add your handling code here:
        createBorrower();
    }//GEN-LAST:event_startButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BorrowerAdministrationGUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea allDataArea;
    private javax.swing.JTextArea dataArea;
    private javax.swing.JLabel dataLabel;
    private javax.swing.JLabel dataLabel1;
    private javax.swing.JButton deleteButton;
    private javax.swing.JButton fileButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField numberTextField;
    private javax.swing.JButton searchButton;
    private javax.swing.JButton showAllButton;
    private javax.swing.JButton showButton;
    private javax.swing.JButton showlButton3;
    private javax.swing.JButton startButton;
    // End of variables declaration//GEN-END:variables
    
}
