// BorrowerCollection .java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.3. 2007.05.27
 * Copyright 2003 by Michael Claudius
 * All rights reserved ?
 */

package library2007;

import java.util.*;
import java.io.*;


public class BorrowerCollection {
    
    // Ass.  declaration of data fields
    private List <Borrower> borrowers;
    
    
    // Ass.  Declaration of constructors
    BorrowerCollection() {
        borrowers = new ArrayList<Borrower> ();
    }//constructor
    
    
    // Ass. Add a borrower always; return true
    public boolean addBorrower(Borrower aBorrower) {
        borrowers.add(aBorrower); //using the List operation!
        return true;
    }
    
    // Ass.  Extra: Create and add a borrower; always return true
    public boolean enterBorrowerInfo(String cprNo, String name, String bType,
            int year) {
        Borrower b = new Borrower(cprNo, name, bType, year);     
        borrowers.add(b);//using the List operation!
        return true;
    }
    
    public boolean makeBorrower(String cprNo, String name, String bType,
            int year) {
        Borrower b = new Borrower(cprNo, name, bType, year);     
        borrowers.add(b);//using the List operation!
        return true;
    }
    // Ass. building up a string of borrowers data
    
    public String allBorrowersData() {
        String s = "";
        for (Borrower b : borrowers) {
            s = s + b.borrowerData() + "\n";
        }
        return s;
    }
    
    //Alternatively using the toString method in ArrayList
    public String toString() {
        return borrowers.toString();
        
    }
    
    
    
    //Ass. 5 Note there is no maximum of borrowers
    public int numberOfBorrowers() {
        return borrowers.size();
    }
    
    
    // Ass. Check index. Return aBorrower
    public Borrower getBorrower(int index) {
        if (index >= 0 && index < borrowers.size() ){
            Borrower b = borrowers.get(index);
            return b;
        } else
            return null;
    }
    
    // Ass. Traverse collection. Search and return aBorrower
    public Borrower getBorrower(String cprNo) {
        String myCprNo;
        for (Borrower b : borrowers) {
            myCprNo = b.getCprNo();
            if ( myCprNo.equals(cprNo) ) {
                return b;
            }
        }
        return null; // not found
    }
    
    
    // Ass. Check index. Typecast, Remove and remove aBorrower
    public Borrower removeBorrower(int index) {
        if (index >= 0 && index < borrowers.size() ) {
            Borrower aBorrower = (Borrower) borrowers.get(index);
            borrowers.remove(index);
            return aBorrower;
        } else
            return null;
    }
    
   
    
    // Ass. Traverse collection. Remove and return aBorrower
    public Borrower removeBorrower(String cprNo) {
        String myCprNo;
        for (Borrower b : borrowers) {
            myCprNo = b.getCprNo();
            if ( myCprNo.equals(cprNo) ) {
                borrowers.remove(b);
                return b;
            }
        }
        
        return null; // not found
    }
    
    
    
    
    
    // Alternatively
    // Ass.Utilize getBorrower. Typecast and return aBorrower
    public Borrower removeBorrowerNew(String cprNo) {
        Borrower aBorrower = getBorrower(cprNo);
        if (aBorrower != null) {
            //found one to be removed
            borrowers.remove(aBorrower); }
        return aBorrower;
        
    }
    
    
    
    public static void main(String[] args) {
        // TODO code application logic here
        BorrowerCollection borrowerCol = new BorrowerCollection();
        
        Borrower b1 = new Borrower("150561-7777", "TheBoss", "Adult", 2005);
        Borrower b2 = new Borrower("15081-7777", "Zhen Zhao", "Adult", 2005);
        Borrower b3 = new Borrower("10080-7777", "Vaida Caiser", "Adult", 2005);
        
        borrowerCol.addBorrower(b1);
        borrowerCol.addBorrower(b2);
        borrowerCol.addBorrower(b3);
        System.out.println(borrowerCol.allBorrowersData());
        
        System.out.println(borrowerCol);  //uses automatically toString method
    }
    
    
    
}
