//BorrowerCollectionConcatenateFile.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2003.12.03
 * Copyright 2003 by Michael Claudius
 * All rights reserved
 */

package library2007;

import java.io.*;

public class BorrowerConcatenateFileOld {
    
    private Borrower aBorrower;
    private String outputFileName, childFileName, adultFileName;
    
    BorrowerConcatenateFileOld(String outputFileName, String childFileName, String adultFileName) {
        
        this.outputFileName = outputFileName;
        this.childFileName  = childFileName;
        this.adultFileName  = adultFileName;
    }
    
    public void doIt() {
        
        try {
            FileOutputStream 	fos = new FileOutputStream(outputFileName);
            ObjectOutputStream  oos = new ObjectOutputStream(fos);
            
            FileInputStream     childFile = new FileInputStream(childFileName);
            ObjectInputStream	childStream = new ObjectInputStream(childFile);
            
            FileInputStream	adultFile = new FileInputStream(adultFileName);
            ObjectInputStream	adultStream = new ObjectInputStream(adultFile);
            
            //Assuming numbers are known and written
            
            int numberChilds = childStream.readInt();
            int numberAdults = adultStream.readInt();
            int numbers = numberChilds + numberAdults;
            
            oos.writeInt(numbers);
            for(int i = 0; i < numberChilds; i ++) {
                aBorrower = (Borrower)childStream.readObject();
                oos.writeObject(aBorrower);
            }
            
            
            for(int i = 0; i < numberAdults; i ++) {
                aBorrower = (Borrower)adultStream.readObject();
                oos.writeObject(aBorrower);
            }
            
             
            childStream.close();
            adultStream.close();
            oos.close();
            
        }//try
        
        catch (IOException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }
        
        catch (ClassNotFoundException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }
        
        
    }// doIt
    
}// class
