// BorrowerFileHandlingGUI.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2006.05.30
 * Copyright 2006 by Michael Claudius
 * All rights reserved
 */
package library2007;
import javax.swing.JOptionPane;
/**
 *
 * @author  admin
 */
public class BorrowerFileHandlingGUI extends javax.swing.JFrame {
    
       public BorrowerFileHandlingGUI() {
        initComponents();
        borrowerCol = new BorrowerCollection();
    }
    
    public BorrowerFileHandlingGUI(BorrowerCollection borrowerCol) {
        initComponents();
        this.borrowerCol = borrowerCol;
    }
    
    Borrower b;
    BorrowerCollection borrowerCol;
    
    private void showNumbers() {
        int num = borrowerCol.numberOfBorrowers();
        String numStr = new Integer(num).toString();
        numberTextField.setText(numStr);
    }
    
    private String printEmptyLines(int noLines) {
        String s = "";
        for (int i = 0; i < noLines; i++)
            s = s +  "\n";
        return s;
    }
    
    private void writeBorrowersToFile() {
        //String fileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\";
        String fileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        fileName = fileName + JOptionPane.showInputDialog("State File Name: ");
        BorrowerWriteFile cmc_WriteFile = new BorrowerWriteFile(borrowerCol, fileName);
        cmc_WriteFile.doIt();
        
    }
    
    private void readBorrowersFromFile() {
       // borrowerCol = new BorrowerCollection();
        //String fileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\";
        String fileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        fileName = fileName + JOptionPane.showInputDialog("State File Name: ");
        BorrowerReadFile cmc_ReadFile = new BorrowerReadFile(borrowerCol, fileName);
        cmc_ReadFile.doIt();
        showNumbers();
        allDataArea.setText(borrowerCol.allBorrowersData());
    }
    
    private void splitBorrowersInToFiles() {
        BorrowerCollection br = new BorrowerCollection();
        //String inputFileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\";
        String inputFileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        inputFileName = inputFileName + JOptionPane.showInputDialog("State Input File Name: ");
        
        String childFileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        childFileName = childFileName + JOptionPane.showInputDialog("State Output File Name for child Borrowers: ");
        
        String adultFileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        adultFileName = adultFileName + JOptionPane.showInputDialog("State Output File Name for adult Borrowers: ");
            
        BorrowerSplitFile cmc_SplitFile = new BorrowerSplitFile(inputFileName, childFileName, adultFileName);
        cmc_SplitFile.doIt();
        
        BorrowerReadFile cmc_ReadFile = new BorrowerReadFile(br, childFileName);
        cmc_ReadFile.doIt();
        
        numberTextField.setText(""+br.numberOfBorrowers() );
        allDataArea.setText(br.allBorrowersData() );      
      
    }
    
    
    private void concatBorrowersFromFiles() {
       BorrowerCollection br = new BorrowerCollection();
        //String fileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\";
        String childFileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        childFileName = childFileName + JOptionPane.showInputDialog("State Child Borrower File Name: ");
        
        String adultFileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        adultFileName = adultFileName + JOptionPane.showInputDialog("State Adult File Name: ");
        
        String outputFileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\";
        outputFileName = outputFileName + JOptionPane.showInputDialog("State Output File Name: ");
        
        BorrowerConcatenateFile cmc_ConcatFile = new BorrowerConcatenateFile(outputFileName, adultFileName, childFileName);
        cmc_ConcatFile.doIt();
        
        BorrowerReadFile cmc_ReadFile = new BorrowerReadFile(br, outputFileName);
        cmc_ReadFile.doIt();
        
        allDataArea.setText(br.allBorrowersData() );
        numberTextField.setText(""+br.numberOfBorrowers() );
        
    }
    
    public void closeWindow() {
        this.dispose();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        dataAllLabel = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        allDataArea = new javax.swing.JTextArea();
        readButton = new javax.swing.JButton();
        writeButton = new javax.swing.JButton();
        splitButton = new javax.swing.JButton();
        concatenateButton = new javax.swing.JButton();
        windowButton = new javax.swing.JButton();
        numberTextField = new javax.swing.JTextField();
        noLabel = new javax.swing.JLabel();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setPreferredSize(new java.awt.Dimension(800, 600));
        dataAllLabel.setFont(new java.awt.Font("MS Sans Serif", 0, 14));
        dataAllLabel.setText("All Borrowers Data");
        jPanel1.add(dataAllLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 70, 120, -1));

        jScrollPane2.setViewportView(allDataArea);

        jPanel1.add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 110, 320, 450));

        readButton.setText("Read Borrowers from File");
        readButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                readButtonActionPerformed(evt);
            }
        });

        jPanel1.add(readButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 180, 180, -1));

        writeButton.setText("Write Borrowers to File");
        writeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                writeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(writeButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 120, 180, -1));

        splitButton.setText("Split Borrowers from File");
        splitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                splitButtonActionPerformed(evt);
            }
        });

        jPanel1.add(splitButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 240, 180, -1));

        concatenateButton.setText("Concatenate Borrowers from Files");
        concatenateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                concatenateButtonActionPerformed(evt);
            }
        });

        jPanel1.add(concatenateButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 300, 180, -1));

        windowButton.setText("Close Window");
        windowButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                windowButtonActionPerformed(evt);
            }
        });

        jPanel1.add(windowButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 390, 180, -1));

        numberTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                numberTextFieldActionPerformed(evt);
            }
        });

        jPanel1.add(numberTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(300, 150, 70, -1));

        noLabel.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        noLabel.setText("Total number");
        jPanel1.add(noLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(300, 120, 90, 20));

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, -1, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void numberTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_numberTextFieldActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_numberTextFieldActionPerformed

    private void windowButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_windowButtonActionPerformed
// TODO add your handling code here:
        closeWindow();
    }//GEN-LAST:event_windowButtonActionPerformed

    private void concatenateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_concatenateButtonActionPerformed
// TODO add your handling code here:
        concatBorrowersFromFiles();
    }//GEN-LAST:event_concatenateButtonActionPerformed

    private void splitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_splitButtonActionPerformed
// TODO add your handling code here:
        splitBorrowersInToFiles();
    }//GEN-LAST:event_splitButtonActionPerformed

    private void writeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_writeButtonActionPerformed
// TODO add your handling code here:
        writeBorrowersToFile();
    }//GEN-LAST:event_writeButtonActionPerformed

    private void readButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readButtonActionPerformed
// TODO add your handling code here:
        readBorrowersFromFile();
    }//GEN-LAST:event_readButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BorrowerFileHandlingGUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea allDataArea;
    private javax.swing.JButton concatenateButton;
    private javax.swing.JLabel dataAllLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel noLabel;
    private javax.swing.JTextField numberTextField;
    private javax.swing.JButton readButton;
    private javax.swing.JButton splitButton;
    private javax.swing.JButton windowButton;
    private javax.swing.JButton writeButton;
    // End of variables declaration//GEN-END:variables
    
}
