//BorrowerGUI.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2007.03.20
 * Copyright 2007 by Michael Claudius
 * All rights reserved ?
*/
package library2007;

import javax.swing.*;

public class BorrowerGUI extends javax.swing.JFrame {
    
    /** Creates new form BorrowerGUI */
    public BorrowerGUI() {
        initComponents();
    }
    
    Borrower b;
    
  private void createBorrower() {
        
        dataArea.setText("");
                   
        String name = JOptionPane.showInputDialog("State name of borrower: ");
                      
        String yearStr = JOptionPane.showInputDialog("State year of registration: ");
        int year = Integer.parseInt(yearStr);
                
        //String bType = JOptionPane.showInputDialog("Type of borrower:\n"+"Adult", "Normal");
        Object[] possibleValues = { "Adult", "Child"};
        String  bType = (String) JOptionPane.showInputDialog(null, "Choose Borrower Type", "Input",
                                                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[1]);     
        b = new Borrower(name, bType, year);
             
    }

    private void showBorrower() {
        dataArea.append(b.borrowerData());
        printEmptyLines(3);
    }
    
    private void calculate() {
        String noItemsStr = JOptionPane.showInputDialog("State number of books: ");
        int noItems = Integer.parseInt(noItemsStr);
        String noOfDaysStr = JOptionPane.showInputDialog("State number of days: ");
        int noOfDays = Integer.parseInt(noOfDaysStr);
        
        double totalPrice = b.calculateBill(noItems, noOfDays);
        
        String text ="";
        if (totalPrice < 1)
            text = "Books are on time no fine to be paid" + "\n" +
                   "Thank you for beeing a good customer and polite to other borrowers";
        else
            text = "Dear "+ b.getName() + "\n" +
                   "Number of books" + noItems + "\n" +
                   "are " + noOfDays + " days too late" + "\n" +
                   "Total fine is: " + totalPrice + " DKK" + "\n";
        
        billArea.append(text);   
        printEmptyLines(3);
    }
    
    private void printEmptyLines(int noLines) {
        for (int i = 0; i < noLines; i++)
            dataArea.append("\n");        
     }
   
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        startButton = new javax.swing.JButton();
        showButton = new javax.swing.JButton();
        dataLabel = new javax.swing.JLabel();
        calculateButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        dataArea = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        billArea = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        startButton.setText("Create Borrower");
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        showButton.setText("Show Borrower");
        showButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showButtonActionPerformed(evt);
            }
        });

        dataLabel.setFont(new java.awt.Font("MS Sans Serif", 0, 14));
        dataLabel.setText("Borrower Data");

        calculateButton.setText("Calculate Fine");
        calculateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                calculateButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("Fine to be paid");

        dataArea.setColumns(20);
        dataArea.setRows(5);
        jScrollPane1.setViewportView(dataArea);

        billArea.setColumns(20);
        billArea.setRows(5);
        jScrollPane2.setViewportView(billArea);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(315, Short.MAX_VALUE)
                .add(dataLabel)
                .add(102, 102, 102))
            .add(layout.createSequentialGroup()
                .add(51, 51, 51)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, calculateButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, showButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, startButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(137, 137, 137)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(45, 45, 45))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(34, 34, 34)
                .add(dataLabel)
                .add(21, 21, 21)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(startButton)
                        .add(16, 16, 16)
                        .add(showButton)
                        .add(75, 75, 75)
                        .add(calculateButton))
                    .add(layout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 126, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(57, 57, 57)
                        .add(jLabel1)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 73, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(19, 19, 19))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void calculateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_calculateButtonActionPerformed
// TODO add your handling code here:
        calculate();
    }//GEN-LAST:event_calculateButtonActionPerformed

    private void showButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showButtonActionPerformed
// TODO add your handling code here:
        showBorrower();
    }//GEN-LAST:event_showButtonActionPerformed

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
// TODO add your handling code here:
        createBorrower();
    }//GEN-LAST:event_startButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BorrowerGUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea billArea;
    private javax.swing.JButton calculateButton;
    private javax.swing.JTextArea dataArea;
    private javax.swing.JLabel dataLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton showButton;
    private javax.swing.JButton startButton;
    // End of variables declaration//GEN-END:variables
    
}
