// BorrowerReadFile.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2003.11.30
 * Copyright 2003 by Michael Claudius
 * All rights reserved
 */

package library2007;

import java.io.*;

public class BorrowerReadFile {
    
    private Borrower aBorrower;
    private BorrowerCollection borrowerCol;
    private String fileName;
    
    BorrowerReadFile(BorrowerCollection borrowerCol, String fileName) {
        this.borrowerCol = borrowerCol;
        this.fileName = fileName;
    }
    
    public void doIt() {
        
        try {
            FileInputStream fis = new FileInputStream(fileName);
            ObjectInputStream ois = new ObjectInputStream(fis);
            int number = ois.readInt();
            
            for (int i=0; i < number; i++)  {
                aBorrower = (Borrower)ois.readObject();
                borrowerCol.addBorrower(aBorrower);
            } //while
            
            ois.close();
        }//try
        
        catch (IOException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }
        
        catch (ClassNotFoundException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }      
    }// doIt
    
    public static void main(String[] args) {
        
        BorrowerCollection borrowerCol = new BorrowerCollection();
        
        //String fileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\" + "borrower.data";
        String fileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions"
            +"\\"  + "borrower.data";
        BorrowerReadFile cmc_ReadFile = new BorrowerReadFile(borrowerCol, fileName);
        cmc_ReadFile.doIt();
                
        System.out.println(borrowerCol.allBorrowersData());
           }
    
}// class
