// BorrowerWriteFile.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2003.04.30 revised 2005.05.10
 * Copyright 2003 by Michael Claudius
 * All rights reserved
*/

package library2007;

import java.io.*;
//import library2007.*;

public class BorrowerWriteFile {

    private Borrower aBorrower;
    private BorrowerCollection borrowerCol;
    private String fileName;

    BorrowerWriteFile(BorrowerCollection borrowerCol, String fileName) {
            this.borrowerCol = borrowerCol;
            this.fileName = fileName;
    }

    public void doIt() {

            try {
                    FileOutputStream fos = new FileOutputStream(fileName);
                    ObjectOutputStream oos = new ObjectOutputStream(fos);

                    int number = borrowerCol.numberOfBorrowers();
                    oos.writeInt(number);
                    for (int index = 0; index < number; index++) {
                            aBorrower = borrowerCol.getBorrower(index);
                            oos.writeObject(aBorrower);
                    } //for
                    oos.close();

            }//try

            catch (IOException ex) {
                    System.out.println(ex.getMessage());
                    ex.printStackTrace();
            }
    }// doIt

      public static void main(String[] args) {
        
            BorrowerCollection borrowerCol = new BorrowerCollection();
            
            Borrower b1 = new Borrower("150561-7777", "TheBoss", "Adult", 2005);
            Borrower b2 = new Borrower("15081-7777", "Zhen Zhao", "Adult", 2005);
            Borrower b3 = new Borrower("10080-7777", "Vaida Caiser", "Adult", 2005);
            
            borrowerCol.addBorrower(b1);
            borrowerCol.addBorrower(b2);
            borrowerCol.addBorrower(b3);
            
            System.out.println(borrowerCol.allBorrowersData());
            
            //String fileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\" + "borrower.data";
            String fileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\"  + "Prog2" +"\\"+"Solutions" +"\\"
            + "borrower.data";
            BorrowerWriteFile cmc_WriteFile = new BorrowerWriteFile(borrowerCol, fileName);
            cmc_WriteFile.doIt();
    }
        
}// class
