// Hits.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2003.04.28 Revised 1.1 2005.
 * Copyright 2003 by Michael Claudius
 * All rights reserved ?
*/

package library2007;

public class Hits {

	// Ass. 1 declaration of data fields
	private int indexMax, indexMin, max, min, total, size =8;
        private double average;
	private int[] data;


	// Ass. 2 declaration of constructors and methods
	Hits() {
		data = new int[size];
		for (int i=0; i < data.length; i++) data[i]=0;
		setMax();
		setMin();
	}//constructor

	Hits(int noPages) {
		data = new int[noPages];
		for (int i=0; i < data.length; i++) data[i]=0;
		setMax();
		setMin();
	}//constructor

//Ass. 3
	// initialize data and then find max and min
	public void initializeData() {
		for (int i=0; i < data.length; i++)
			data[i] = (int)(Math.random()*1000);
		setMin();
		setMax();

	}

	public String hitsData() {
		String s = "";
		for (int i=0; i < data.length; i++)
			s = s + i + " " + data[i] + " " + "\n";
		return s;
	}

	public String toString() {
		String s = "";
		for (int i=0; i < data.length; i++)
			s = s + i + " " + data[i] + " " + "\n";
		return s;
	}


// Ass 5
	public int total() {
		int sum = 0;
		for (int i=0; i < data.length; i++)
			 sum = sum + data[i];
		total = sum;
                return total;
	}

	public int getTtotal() {
            return total;
        }

// Ass 6
	public double average() {
		average = 1.0*total()/data.length;
                return average;
	}
        
	public int getAverage() {
            return total;
        }


// Ass 7
	private void setMax() {
		max = data[0]; indexMax = 0;
		for (int i=1; i < data.length; i++) {
			if (data[i] > max) {
				max = data[i];
				indexMax = i;
			}
		}
	}

 	public int getMax() {
	   return max;
	}//getMax

	public int getIndexMax() {
	   return indexMax;
	}//getMax


// Ass 8
	private void setMin() {
		min = data[0]; indexMin = 0;
		for (int i=1; i < data.length; i++) {
			if (data[i] < min ) {
				min = data[i];
				indexMin = i;
			}
		}
	}


	public int getMin() {
	   return min;
	}

	public int getIndexMin() {
	   return indexMin;
	}


// Ass 9
	public double stdDeviation() {
		double sumSquares = 0.0;
		for (int i=0; i < data.length; i++) {
			sumSquares = sumSquares + data[i]*data[i];
		}
		return Math.sqrt((sumSquares/size) - average()*average());
	}

       	
// Ass 12
	//set value at an index. remember to change min/max
	// if necessary !

	public void setValue(int aIndex, int aValue) {
		data[aIndex] = aValue;
		if (aValue > max) {
			indexMax = aIndex;
			max = aValue;
			if (aIndex == indexMin) setMin();
		} else
		if (aValue < min) {
			indexMin = aIndex;
			min = aValue;
			if (aIndex == indexMax) setMax();
		}
	}

// Ass 12
	//set value at an index. changes always min/max
	// although this might not be necessary
	// easier written but bad performance !

	public void setValueSimple(int aIndex, int aValue) {
		data[aIndex] = aValue;
		setMax();
		setMin();
	}

// Ass 10 / 11
	Hits(int[] newData) {
		data = new int[newData.length];
                System.arraycopy(newData, 0, data, 0, data.length);
		// alternatively
                //for (int i=0; i < data.length; i++) data[i]= newData[i];
		setMax();
		setMin();
	}//constructor


// Ass 14
	public Hits sort() {
		int[] sortData = new int[data.length];
		for (int i=0; i < data.length; i++)
		   sortData[i]= data[i];
		java.util.Arrays.sort(sortData); //SelectionSort.selectionSort(sortData);
		return new Hits(sortData);
	}


	// Ass 2 and others
	public String statData() {
		String s =	"Statistics data: " + "\n" + 
					"Sum = "+ this.total() + "\n" +
					"Average = "+ this.average() + "\n" +
					"Maximum = "+ this.getMax() + "\n" +
                                        "Minimum = "+ this.getMin()  + "\n" +
					"Standard deviation = "+ this.stdDeviation();
		return s;
}

        public static void main (String[] args) {
              Hits myHits = new Hits();
              System.out.println(myHits.hitsData());
              myHits.initializeData();
              System.out.println(myHits.statData());
              
              int[] data = new int[5];
              for (int i=0; i < data.length; i++)
                  data[i] = (int)(Math.random()*1000);

              
              Hits newHits = new Hits(data);
              System.out.println(myHits.statData());
              
              
        }

}